C ********************************************************************
C * BANDPLOT - Plotting and interpolation of energy bands            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  BPOPEN                                                          *
C *                                                                  *
C *  Usage......: Assigns free units to files beginning from UNIT 7. *                       
C *                                                                  *
C *  Author.....: Martin Braendle                                    *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute for Inorg. and Phys. Chemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: 09.07.97                                           *
C *  Revision...: -                                                  *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: BFIT                                               *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE BPOPEN(IUNIT,SFORM,SSTAT,SFILE)

      INTEGER       IUNIT,I
      LOGICAL       FOPEN
      CHARACTER*(*) SFORM,SSTAT,SFILE

      I=6
      FOPEN=.TRUE.
      DO WHILE (FOPEN)
        I=I+1
        INQUIRE(UNIT=I,OPENED=FOPEN)
      END DO
      IUNIT=I

      IF (INDEX(SFILE,' ') .EQ. 1) THEN
        OPEN(UNIT=IUNIT,FORM=SFORM,STATUS=SSTAT)
      ELSE
        OPEN(UNIT=IUNIT,FORM=SFORM,STATUS=SSTAT,FILE=SFILE)
      ENDIF

      RETURN
      END
