C ********************************************************************
C * BANDPLOT - Plotting and interpolation of energy bands            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  BPSRT2                                                          *
C *                                                                  *
C *  Routine of BANDPLOT                                             *
C *                                                                  *
C *  Usage......: Orders energy levels according to IORD info.       *
C *                                                                  *
C *  Authors....: Martin Braendle (mbs)                              *
C *  Available..: Calzaferri group c/o                               *
C *               Institute for Inorg. + Phys. Chemistry             *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: 06.09.94                                           *
C *  Revision...: 01.07.97/mbs                                       *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: BANDPLOT                                           *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE BPSRT2(ERAW,EBUFF,IORD,NNOFIT,NBFIT,NBTOT,NK)
C
C NAG/GKS version.
C 
C      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
C
C PGPLOT version.
C
      IMPLICIT REAL(A-H,O-Z)
 
      INCLUDE 'sizes'
 
      DIMENSION ERAW(MAXBA,MAXK),EBUFF(MAXBA,MAXK),IORD(MAXBA,MAXK)
 
C
C Order energies. First copy them to a buffer.
C
      DO K=1,NK
        DO J=1,NBTOT
          EBUFF(J,K)=ERAW(J,K)
        END DO
      END DO
 
      DO K=1,NK
        DO J=NNOFIT+1,NNOFIT+NBFIT
          IBAND1=J
          IBAND2=IORD(IBAND1,K)
          ERAW(IBAND2,K)=EBUFF(IBAND1,K)
        END DO
      END DO
 
      RETURN
      END