C ********************************************************************
C * CEDiT - Crystal Electronic Dipole-induced Transitions            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  SUBROUTINE DIAG                                                 *
C *                                                                  *
C *  Routine of EDiT/CEDiT                                           *
C *  version for IBM-PC MS-DOS, Microsoft FORTRAN and                *
C *              IBM-RISC UNIX, AIX XL FORTRAN                       * 
C *                                                                  *
C *  Usage......: Calculates the diagonal elements of the            *
C *               transition matrix.                                 *
C *                                                                  *
C *  Authors....: Ruedi Rytz                                         *
C *                                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute for anorg. + phys. Chemistry             *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: June 1992                                          *
C *  Revision...: -                                                  *
C *                                                                  *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: MATRIX                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE DIAG (M, ANZATO,
     .                 X, Y, Z, FAO, LAO, POL)

      IMPLICIT NONE

      INCLUDE 'sizes'

        DOUBLE PRECISION M(MAXAO,MAXAO)
        INTEGER          ANZATO
        DOUBLE PRECISION X(MAXATO), Y(MAXATO), Z(MAXATO)
        INTEGER          FAO(MAXATO), LAO(MAXATO)
        CHARACTER*1      POL

C VAR
      INTEGER I, J, L
      DOUBLE PRECISION  FAC

C BEGIN
      L = 0
      DO 10 I = 1, ANZATO

        IF (POL .EQ. 'X') THEN
          FAC = X(I) * AUI
        ELSEIF (POL .EQ. 'Y') THEN
          FAC = Y(I) * AUI
        ELSE
          FAC = Z(I) * AUI
        ENDIF

        DO 20 J = 1, ( LAO(I) - FAO(I) + 1 )
          L = L + 1
          M(L,L) = M(L,L) * FAC
20      CONTINUE

10    CONTINUE

      RETURN
      END

C END
