C ********************************************************************
C * DOSPLOT -  Plots density of states (DOS)                         *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  DPLIST                                                          *
C *                                                                  *
C *  Routine of DOSPLOT                                              *
C *                                                                  *
C *  Usage......: Lists DOS/COOP buffer contents.                    *
C *                                                                  *
C *  Author.....: Martin Braendle (mbs)                              *
C *  Available..: Calzaferri group, Institute for Inorganic and      *
C *               Physical Chemistry, University of Berne, Freiestr. *
C *               3, CH-3012 Berne, Switzerland                      *
C *  Date.......: 01.09.1994                                         *
C *  Revision...: -                                                  *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: DPGRPH                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE DPLIST(IBUFDS,IBUFCP,BUFTIT)
C
C NAG/GKS version.
C 
C      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
C
C PGPLOT version.
C
      IMPLICIT REAL(A-H,O-Z)

      INCLUDE 'sizes'
 
      CHARACTER*72 BUFTIT(2*MAXBUF)
 
      IF (IBUFDS .GT. 0) THEN
        WRITE(6,'(/,'' DOS buffers:'',/)')
        DO I=1,IBUFDS
          WRITE(6,'(1X,I2,1X,A72)') I,BUFTIT(I)
        END DO
      ENDIF
 
      IF (IBUFCP .GT. 0) THEN
        WRITE(6,'(/,'' COOP buffers:'',/)')
        DO I=1,IBUFCP
          WRITE(6,'(1X,I2,1X,A72)') MAXBUF+I,BUFTIT(MAXBUF+I)
        END DO
      ENDIF
 
      RETURN
      END