C ********************************************************************
C * DOSPLOT -  Plots density of states (DOS)                         *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  DPTEXT                                                          *
C *                                                                  *
C *  Routine of DOSPLOT                                              *
C *                                                                  *
C *  Usage......: Redraws text.                                      *
C *                                                                  *
C *  Author.....: Martin Braendle (mbs) c/o                          *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute for anorg. + phys. Chemistry             *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: 21.04.92                                           *
C *  Revision...: 18.06.97/mbs                                       *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: DOSPLT,DPGRPH                                      *
C *                                                                  *
C *  Calls......: DPTRAN,DPTRAP                                      *
C *               PGPLOT routines PGSWIN,PGSVP                       *   
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE DPTEXT(VPXFUL,VPYFUL,TEXTXY,TXTANG,ITXPOS,ITXT,CTEXT)
C
C NAG/GKS version.
C 
C      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C PGPLOT version.
C
      IMPLICIT REAL(A-H,O-Z) 
 
      INCLUDE 'sizes'
      PARAMETER (MARGIN=0,ILEFT=0)
 
      DIMENSION    TEXTXY(MXTEXT,2),TXTANG(MXTEXT),ITXPOS(MXTEXT)
      CHARACTER*80 CTEXT(MXTEXT)
 
C
C Set datarange and viewport.
C
C NAG/GKS version.
C
C      CALL J06WBF(0.0,VPXFUL,0.0,VPYFUL,MARGIN)
C      CALL J06WCF(0.0,VPXFUL,0.0,VPYFUL)
C
C PGPLOT version.
C
      CALL PGSWIN(0.0,VPXFUL,0.0,VPYFUL)
      CALL PGSVP(0.0,VPXFUL,0.0,VPYFUL)
 
      DO I=1,ITXT
C
C NAG/GKS version.
C
C        CALL DPTRAN(CTEXT(I),TEXTXY(I,1),TEXTXY(I,2),ILEFT)
C
C PGPLOT version.
C
        CALL DPTRAP(CTEXT(I),TEXTXY(I,1),TEXTXY(I,2),TXTANG(I),
     .              ITXPOS(I))
      END DO
      RETURN
      END