C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  MATOUT                                                          *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: Matrix output of an (IR,IC) segment of a (ND,ND)   *
C *               matrix.                                            *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987                                          *
C *  Remarks....: may be used later ...                              *
C *                                                                  *
C *  Called from: -                                                  *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
      SUBROUTINE MATOUT(A,ND,IR,IC)

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      INCLUDE 'sizes'

      COMMON /IOUNIT/ IIN,IOUT,ISTART(40)

      DIMENSION A(ND,ND)

      N=IC/14
      IF (N*14 .NE. IC) N=N+1

      DO 40 M=1,N
        IU=M*14
        IL=IU-13
        IF (IU .GT. IC) IU=IC
        WRITE(IOUT,10) (L,L=IL,IU)
   10   FORMAT(/,9X,14(I4,4X))
        WRITE(IOUT,20)
   20   FORMAT(' ')
        DO 40 I=1,IR
          WRITE(IOUT,30) I,(A(I,K),K=IL,IU)
   30 FORMAT(I5,2X,14F8.4)
   40 CONTINUE
      RETURN
      END
