C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  MOPOP                                                           *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: Output routine.                                    *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987                                          *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: POPULA                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE MOPOP(A,NDD,IR,IC)
 
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
 
      INCLUDE 'sizes'
 
      DIMENSION A(NDD,NDD)
 
      COMMON /IOUNIT/IIN,IOUT,ISTART(40)
      COMMON /ATOM1/NS(NSYMMX,NAEQMX),NP(NSYMMX),ND(NSYMMX),NF(NSYMMX),
     .              INATOM,ISYM(NATMMX),NELEM

      COMMON /ATO/AC(NATMMX),SYMBOL(NSYMMX)
      CHARACTER AC*7,SYMBOL*2

      N=IC/12
      IF (N*12 .NE. IC) N=N+1

      DO 30 M=1,N
        IU=M*12
        IL=IU-11
        IC1=IC-1
        IF (IU .GT. IC1) IU=IC1
        WRITE(IOUT,10) (AC(L),L=IL,IU)
   10   FORMAT(//,11X,12(A7,1X),/)
        JF=(M-1)*12+2
        DO 30 I=JF,IR
          IUU=MIN(IU,I-1)
          WRITE(IOUT,20) AC(I),(A(I,K),K=IL,IUU)
   20     FORMAT(1X,A7,2X,12F8.4)
   30 CONTINUE

      RETURN
      END
