C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  OMF1                                                            *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: Output routine for fragment CO coefficients.       *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987, 06.05.92/mbs (Martin Braendle, c/o      *
C *               Calzaferri group, Inst. f. Inorg. and Phys. Chem., *
C *               Freiestr. 3, CH-3012 Berne)                        *
C *  Remarks....: Slight modification of COMMON blocks.              *
C *                                                                  *
C *  Called from: BFMO                                               *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE OMF1(X,Y,NN)

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      INCLUDE 'sizes'

      DIMENSION X(NN,NN),Y(NN,NN)
      CHARACTER LEG*12

      COMMON /IOUNIT/IIN,IOUT,ISTART(40)
      COMMON /DELET/IND(NDIMMX),INDIM,IVAL,NORBE(NATMMX),NDEL
      COMMON /ATOM1/NS(NSYMMX,NAEQMX),NP(NSYMMX),ND(NSYMMX),NF(NSYMMX),
     .              INATOM,ISYM(NATMMX),NELEM
      COMMON /AOOUT1/INDTS(NDIMMX)
      COMMON /FMOIO/IFMOIN(NDIMMX,NFMOMX),IFMOO(NDIMMX,NFMOMX),
     .              NDIMFR(NFMOMX),IFMOP(11,NFMOMX),NFMO
      COMMON /OPTV/RHO,FERMI,WSTART,WEND,DISTL,LB,LE,LBR,LER,IOVLB,
     .             IOVLE,ICHARG,NELEC,IDISTN,IEB,IEE,ISB,ISE,IHB,IHE,
     .             IPOPE,JPOPE,IREST,IRESTV

      COMMON /ATO/AC(NATMMX),SYMBOL(NSYMMX)
      CHARACTER AC*7,SYMBOL*2

      COMMON /AOOUT2/INDT(NDIMMX,2)
      CHARACTER INDT*10

      LEG='real    imag'
      IFLAG=1
      ILOWER=LB
      NL=LE
 
   10 IUPPER=ILOWER+5
      IF (IUPPER-NL) 30,20,20
   20 IUPPER=NL
      IFLAG=0
   30 WRITE(IOUT,40) (J,J=ILOWER,IUPPER)
   40 FORMAT(/,25X,5(I10,8X),I10,/)
      WRITE(IOUT,50) (LEG,J=ILOWER,IUPPER)
   50 FORMAT(25X,5(3X,A12,3X),3X,A12)

      IL1=ILOWER
      IU1=IUPPER

      NUMBF=0
      INF=0
      DO 80 I=1,NN
        IF ((INF .EQ. 0) .OR. (INF .GT. NDIMFR(NUMBF))) THEN
          INF=1
          NUMBF=NUMBF+1
          WRITE(IOUT,60) NUMBF,INF,I,(X(I,J),Y(I,J),J=IL1,IU1)
   60     FORMAT(/,1X,'Fragment #',I2,2X,I3,2X,I3,2X,5(2F8.4,2X),2F8.4)
        ELSE
          WRITE(IOUT,70) INF,I,(X(I,J),Y(I,J),J=IL1,IU1)
   70     FORMAT(15X,I3,2X,I3,2X,5(2F8.4,2X),2F8.4)
        ENDIF
        INF=INF+1
   80 CONTINUE
      WRITE(IOUT,90)
   90 FORMAT(' ')

      IF (IFLAG) 100,110,100
  100 ILOWER=ILOWER+6
      GOTO 10

  110 RETURN
      END
