C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  PRBOND                                                          *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: Output of evaluated bonds.                         *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987, 07.05.92/mbs (Martin Braendle c/o       *
C *               Calzaferri group, Inst. f. Inorg. and Phys. Chem., *
C *               Freiestr. 3, CH-3012 Berne)                        *
C *  Remarks....: Slight modification of COMMON blocks.              *
C *                                                                  *
C *  Called from: INMODI                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE PRBOND
 
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      INCLUDE 'sizes'

      CHARACTER ACI1*7,ACI2*7,ACJ1*7,ACJ2*7

      COMMON /IOUNIT/IIN,IOUT,ISTART(40)
      COMMON /BOND2/IDTR(NBONMX,3),DDX(NBONMX),IDBOND,INEXT(NBONMX),
     .              IFIRST,ITYPE(14)

      COMMON /KEYWRD/KEYWRD,SLINE
      CHARACTER KEYWRD*320,SLINE*80

      COMMON /BOND1/IDAT(NBONMX,2)
      CHARACTER*7 IDAT

      ILIM1=IDBOND/2
      IF (ILIM1 .NE. IDBOND*2) ILIM1=ILIM1+1
      IT1=1
      IT2=1
      I1=1
      I2=ILIM1+1
   10 IF ((I1 .GT. ILIM1) .AND. (I2 .GT. IDBOND)) GOTO 60
      ACI1=IDAT(I1,1)
      ACI2=IDAT(I2,1)
      IF (IT1 .EQ. 0) THEN
        ACJ1=IDAT(I1-1,1)
      ELSE
        ACJ1=ACI1
        IT1=0
      ENDIF
      IF (IT2 .EQ. 0) THEN
        ACJ2=IDAT(I2-1,1)
      ELSE
        ACJ2=ACI2
        IT2=0
      ENDIF
      IF (((ACI1(1:5) .NE. ACJ1(1:5)) .OR. (I1 .GT. ILIM1)) .AND. 
     .   (ACI2(1:5) .EQ. ACJ2(1:5))) THEN
        IF (I2 .LE. IDBOND) THEN
          WRITE(IOUT,20) IDAT(I2,1),IDAT(I2,2),DDX(I2),
     .                   (IDTR(I2,J),J=1,3)
   20     FORMAT(62X,1X,A7,2X,'<--->',2X,A7,5X,F10.6,3X,3I3)
          I2=I2+1
          IT1=1
        ELSE
          WRITE(IOUT,40)
          IT1=1
        ENDIF
      ENDIF
      IF ((ACI1(1:5) .EQ. ACJ1(1:5)) .AND. ((ACI2(1:5) .NE. ACJ2(1:5)) 
     .    .OR. (I2 .GT. IDBOND))) THEN
        IF (I1 .LE. ILIM1) THEN
          WRITE(IOUT,30) IDAT(I1,1),IDAT(I1,2),DDX(I1),
     .                   (IDTR(I1,J),J=1,3)
   30     FORMAT(3X,A7,2X,'<--->',2X,A7,5X,F10.6,3X,3I3)
          I1=I1+1
          IT2=1
        ELSE
          WRITE(IOUT,40)
   40     FORMAT(' ')
          IT2=1
        ENDIF
      ENDIF
      IF ((ACI1(1:5) .NE. ACJ1(1:5)) .AND. (ACI2(1:5) .NE. ACJ2(1:5)))
     .THEN
        WRITE(IOUT,40)
        IT1=1
        IT2=1
      ENDIF
      IF ((ACI1(1:5) .EQ. ACJ1(1:5)) .AND. (ACI2(1:5) .EQ. ACJ2(1:5)) 
     .    .AND. (I1 .LE. ILIM1) .AND. (I2 .LE. IDBOND)) THEN
        WRITE(IOUT,50) IDAT(I1,1),IDAT(I1,2),DDX(I1),
     .                 (IDTR(I1,J),J=1,3),IDAT(I2,1),IDAT(I2,2),DDX(I2),
     .                 (IDTR(I2,J),J=1,3)
   50   FORMAT(3X,A7,2X,'<--->',2X,A7,5X,F10.6,3X,3I3,10X,A7,2X,'<--->',
     .         2X,A7,5X,F10.6,3X,3I3)
        I1=I1+1
        I2=I2+1
      ENDIF
      GOTO 10
   60 CONTINUE

      IF (INDEX(KEYWRD,'BOND') .NE. 0) THEN
        DO 80 I=1,IDBOND
          IF ((IDTR(I,1) .EQ. 0) .AND. (IDTR(I,2) .EQ. 0) .AND. 
     .       (IDTR(I,3) .EQ. 0)) WRITE(12,70) IDAT(I,1),IDAT(I,2),0,
     .                                        DDX(I)
   70     FORMAT('Bond  ',A7,2X,A7,2X,I3,2X,F10.6)
   80   CONTINUE
      ENDIF
 
      RETURN
      END
