C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  SREST                                                           *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: Allows to restart band calculations as a function  *
C *               of k after interruption in the middle of a k-point *
C *               set.                                               *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987, 9.04.92/mbs (Martin Braendle c/o        *
C *               Calzaferri group, Inst. f. Inorg. and Phys. Chem., *
C *               Freiestr. 3, CH-3012 Berne), 16.06.92/mbs          *
C *  Remarks....: Units 1 to 4 input will be formatted.              *
C *                                                                  *
C *  Called from: CRYST                                              *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE SREST(IREST,IAOPOP,IFPOP,IOPOP,IVARY,NKP,NDIM,NATOM,
     .                 NELEM,NDEL,NVARY)
 
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
 
      CHARACTER CDUMMY*80
 
      IF (IREST .GT. 1) THEN
        IF (IVARY .EQ. 1) READ(1,10) NKP,NDIM,NATOM,NELEM,NDEL,NVARY
   10   FORMAT(6I6)
        DO 20 I=1,NDIM+NELEM+NATOM
          READ(1,50) CDUMMY
   50     FORMAT(A80)
   20   CONTINUE
        IF (IOPOP .NE. 0) THEN
          READ(3,30) NEQU
   30     FORMAT(I4)
          READ(3,40) IOVLB,IOVLE
   40     FORMAT(2I4)
          DO 130 IB=1,NEQU
            READ(3,50) CDUMMY
  130     CONTINUE
        ENDIF
 
        DO 180 K=1,IREST-1
          DO 140 I=1,NDIM+1
            READ(1,50) CDUMMY
  140     CONTINUE
 
          IF (IAOPOP .NE. 0) THEN
            READ(2,80) IIPOPE
   80       FORMAT(I6)
            DO 150 I=1,IIPOPE*NDIM
              READ(2,50) CDUMMY
  150       CONTINUE
          ENDIF
        
          IF (IOPOP .NE. 0) THEN
            IF (K .NE. 1) READ(3,40) IOVLB,IOVLE
            ILOOP=IOVLE-IOVLB+2
            IF (IOVLB .EQ. 1) ILOOP=ILOOP-1
            DO 160 IL=1,ILOOP*NEQU
              READ(3,50) CDUMMY
  160       CONTINUE
          ENDIF
 
          IF (IFPOP .NE. 0) THEN
            READ(4,80) JJPOPE
            DO 170 I=1,JJPOPE*NDIM
              READ(4,50) CDUMMY
  170       CONTINUE
          ENDIF
  180   CONTINUE
        IF (NVARY .GT. 1) THEN
          READ(1,190) IORD
  190     FORMAT(I2)
          NDK=NDIM*NKP
          DO 200 I=1,NDK
            READ(1,50) CDUMMY
  200     CONTINUE
        ENDIF
      ENDIF
 
      RETURN
      END
