C ********************************************************************
C * EHPC - Extended Hueckel properties calculations                  *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  READL                                                           *
C *                                                                  *
C *  Routine of EHPC                                                 *
C *                                                                  *
C *  Usage......: Reads unformatted input lines.                     *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987                                          *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: GPOPT,GPROJ,GPROJF,GPROJB,                         *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE READL 

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      LOGICAL   LEADSP
      CHARACTER SPACE,COMMA

      COMMON /IOUNIT/IIN,IOUT,ISTART(40)

      COMMON /KEYWRD/KEYWRD,SLINE
      CHARACTER KEYWRD*320,SLINE*80

      DATA COMMA,SPACE /',',' '/

      ILOWA=ICHAR('a')
      ILOWZ=ICHAR('z')
      ICAPA=ICHAR('A')

   10 READ (IIN,'(a)',END=60) SLINE
      IF (SLINE .EQ. ' ') GOTO 10
      IF (INDEX(SLINE,'!') .NE. 0) GOTO 10

      DO 20 I=1,80
        ILINE=ICHAR(SLINE(I:I))
        IF ((ILINE .GE. ILOWA) .AND. (ILINE .LE. ILOWZ)) THEN
          SLINE(I:I)=CHAR(ILINE+ICAPA-ILOWA)
        ENDIF
   20 CONTINUE

      DO 30 I=1,80
   30 IF ((SLINE(I:I) .LT. SPACE) .OR. (SLINE(I:I) .EQ. COMMA) .OR. 
     .    (SLINE(I:I) .GT. CHAR(125))) SLINE(I:I)=SPACE
C
C   initialize istart to interpret blanks as zero's
C
      DO 40 I=1,40
   40 ISTART(I)=81
C
C find initial digit of all numbers, check for leading spaces followed
C by a character and store in istart
C
      LEADSP=.TRUE.
      NVALUE=0
      DO 50 I=1,80
        IF (LEADSP .AND. (SLINE(I:I) .NE. SPACE)) THEN
          NVALUE=NVALUE+1
          ISTART(NVALUE)=I
        ENDIF
        LEADSP=(SLINE(I:I) .EQ. SPACE)
   50 CONTINUE

      RETURN

   60 SLINE='END'
      RETURN
      END
