C ********************************************************************
C * TRANSC - Transformation of Cartesian to Fractional Coordinates   *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  READA                                                           *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: Translates ASCII characters into numbers.          *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987                                          *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: INMODI,                                            *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
      DOUBLE PRECISION FUNCTION READA(A,ISTART,LEN)

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      CHARACTER A(320)

      NINE=ICHAR('9')
      IZERO=ICHAR('0')
      MINUS=ICHAR('-')
      IDOT=ICHAR('.')
      IE=ICHAR('E')
      IDIG=0
      C1=0
      C2=0
      IC3=0
      ONE=1.D0
      TWO=1.D0
      X=1.D0

      DO 10 J=ISTART,LEN
        N=ICHAR(A(J))
        M=ICHAR(A(J+1))
        IF ((N .LE. NINE) .AND. (N .GE. IZERO) .OR. (N .EQ. IDOT)) 
     .  GOTO 20
        IF ((N .EQ. MINUS) .AND. ((M .LE. NINE) .AND. (M .GE. IZERO) 
     .  .OR. (M .EQ. IDOT))) GOTO 20
   10 CONTINUE
      READA=0.D0
      GOTO 110

   20 CONTINUE
      DO 30 I=J,LEN
        N=ICHAR(A(I))
        IF ((N .LE. NINE) .AND. (N .GE. IZERO)) THEN
          IDIG=IDIG+1
          IF (IDIG .GT. 10) GOTO 60
          C1=C1*10+N-IZERO
        ELSE IF ((N .EQ. MINUS) .AND. (I .EQ. J)) THEN
          ONE=-1.D0
        ELSE IF (N .EQ. IDOT) THEN
          GOTO 40
        ELSE
          IF (N .EQ. IE) GOTO 60
          GOTO 80
        ENDIF
   30 CONTINUE
   40 CONTINUE
      IDIG=0
      DO 50 II=I+1,LEN
        N=ICHAR(A(II))
        IF (N .LE. NINE .AND. N .GE. IZERO) THEN
          IDIG=IDIG+1
          IF (IDIG .GT. 10) GOTO 60
          C2=C2*10+N-IZERO
          X=X/10
        ELSE IF (N .EQ. MINUS .AND. II .EQ. I) THEN
          X=-X
        ELSE IF (N .EQ. IE) THEN
          GOTO 60
        ELSE
          GOTO 80
        ENDIF
   50 CONTINUE

   60 IDIG=0
      DO 70 K=II+1,LEN
        N=ICHAR(A(K))
        IF ((N .LE. NINE) .AND. (N .GE. IZERO)) THEN
          IDIG=IDIG+1
          IF (IDIG .GT. 10) GOTO 80
          IC3=IC3*10+N-IZERO
        ELSE IF ((N .EQ. MINUS) .AND. (K .EQ. II+1)) THEN
          TWO=-1.D0
        ELSE
          GOTO 80
        ENDIF
   70 CONTINUE
C
C put the pieces together
C
   80 CONTINUE
      COEFF=1.0D0
      IF (TWO .EQ. -1) THEN
        DO 90 I=1,IC3
          COEFF=COEFF/10.0D0
   90   CONTINUE
      ELSE
        DO 100 I=1,IC3
          COEFF=COEFF*10.0D0
  100   CONTINUE
      ENDIF
      READA=ONE*(C1+C2*X)*COEFF

  110 RETURN
      END
